#-------------------------------------------------------------------------------
# Name:        config.py
# Purpose:
#
# Author:      Daryl
#
# Created:     19/04/2013
# Copyright:   (c) Daryl 2013
# Licence:     <your licence>
#-------------------------------------------------------------------------------

import pygame
from collections import namedtuple

MAX_FPS = 30

#######################################################################
## Window Stats
#######################################################################
WINDOW_SIZE = 640, 480

FIELD_SIZE = 580, 440
FIELD_POS = 0, WINDOW_SIZE[1] - FIELD_SIZE[1]

HUD_SIZE = WINDOW_SIZE[0], WINDOW_SIZE[1] - FIELD_SIZE[1]
HUD_POS = 0, 0

BUTTONS_SIZE = WINDOW_SIZE[0] - FIELD_SIZE[0], WINDOW_SIZE[1] - HUD_SIZE[1]
BUTTONS_POS = FIELD_SIZE[0], HUD_SIZE[1]
BUTTON_IMAGES = ['assets/buttons/btn_bomb.png',
                 'assets/buttons/btn_turbo.png',
                 'assets/buttons/btn_ghost.png',
                 'assets/buttons/btn_poison.png',
                ]

BUTTONS = 4
BTN_SIZE = BUTTONS_SIZE[0] - 8, BUTTONS_SIZE[1] / BUTTONS - 6

#######################################################################
## Player Stats
#######################################################################
PLAYER_SIZE = 25, 25
PLAYER_SPEED = 30
PLAYER_COLORS = [(255, 255,   0), (245, 255,   0), (255, 255,   0), (255, 245,   0)]
PLAYER_START = [PLAYER_SIZE[0] * 2, FIELD_SIZE[1] / 2 - PLAYER_SIZE[1] / 2]
INITIAL_FOLLOWERS = 20

#######################################################################
## Power Stats
#######################################################################
TURBO_TIME = 3.0
GHOST_TIME = 2.0

BOMBER_SIZE = 15, 15
BOMBER_COLORS = [(255,   0,   0), (255, 255,   0), (255, 255, 255), (255, 255,   0),
                 (204,   0, 255), (255, 255,   0), (248, 248, 248), (255, 255,   0)]
BOMB_DURATION = 2.0
BOMBLET_TIME = 1.0

EXPLOSION_RADIUS = 55
EXPLOSION_RATE = 3
EXPLOSION_SEQUENCE = ['assets/fire/sun%d.png' % i for i in (1,2,3,4,5,6,5,4,3,2)]

POISON_SIZE = 15, 15
POISON_COLORS = [(0,   255,   0), (255, 255,   0), (0, 153, 51), (255, 255,   0),
                 (248, 248, 248), (255, 255,   0), (51, 102, 0), (255, 255,   0)]
POISON_DURATION = 3.0
POISON_RADIUS = 75

Power = namedtuple('Power', 'name cost cooldown')
POWERS = [Power('Bomber',  1, 2.0),
          Power('Turbo',   2, 3.0),
          Power('Ghost',   3, 4.0),
          Power('Poison',  5, 5.0),
         ]

#######################################################################
## Village Stats
#######################################################################
PICKUP_SIZE = 19, 19
PICKUP_COLORS = [(0, 0, 255), (0, 0x66, 255), (0, 0, 255), (0x33, 255, 255)]  # Sorry
PICKUP_BONUS = (2, 9)

#######################################################################
## Goo Stats
#######################################################################
GOO_ADVANCE_RATE = 0.1
GOO_DAMAGE_RATE = 10

#######################################################################
## Terrain Generation Info
#######################################################################
TILE_SIZE = tuple(i/8 for i in FIELD_SIZE)
SPOT_SIZE = 5
# Crap! I forgot to make an endgame screen if you finished all 10 levels.
# Problem solved: There are now 1000 levels. :)
LEVEL_DISTANCES = [FIELD_SIZE[0] * (i+2) for i in range(1000)]

#######################################################################
## Key Bindings
#######################################################################
KEYS = {pygame.K_ESCAPE: 'QUIT',
        # Arrow Keys
        pygame.K_LEFT:  'LEFT',
        pygame.K_RIGHT: 'RIGHT',
        pygame.K_UP:    'UP',
        pygame.K_DOWN:  'DOWN',
        # Numpad
        pygame.K_KP4: 'LEFT',
        pygame.K_KP6: 'RIGHT',
        pygame.K_KP8: 'UP',
        pygame.K_KP2: 'DOWN',
        # WASD Keys
        pygame.K_w: 'UP',
        pygame.K_a: 'LEFT',
        pygame.K_s: 'DOWN',
        pygame.K_d: 'RIGHT',
        # Powers
        pygame.K_1: 'POWER_1',
        pygame.K_2: 'POWER_2',
        pygame.K_3: 'POWER_3',
        pygame.K_4: 'POWER_4',
        ##pygame.K_5: 'POWER_5',
        # Other
        pygame.K_p: 'PAUSE',
        pygame.K_o: 'DEBUG',
       }


